
Require Import Ltac2.Ltac2.
Require OverSetoid.
Import OverSetoid.Notations.


Require Import Classes.Morphisms.
Require Import Coq.Relations.Relation_Definitions.
Require Import Setoid.
Require Import Coq.Classes.Morphisms_Prop.

(* Patch for what I want, todo:
  either make this a special case in subrelation handling or move to a setoid_rewrite based aproach *)
Instance subr_eq {A: Type} (R: relation A) : Reflexive R -> subrelation eq R.
Proof.
  intros.
  intros x y [].
  reflexivity.
Qed.

Lemma thatOneWeirdApplicationThatOnlyKyleCaresAbout: 
  (forall x, (x <-> True) \/ (x <-> False))
  -> forall f, Proper (iff ==> iff) f -> forall x, f (f (f x)) <-> f x.
Proof.
  intros.
  destruct (H x);
  destruct (H (f True));
  destruct (H (f False));
  setoid_congruence (iff).
Qed.


Section example_4_4_4.
  Context {A: Type} (RA: relation A) `{!Equivalence RA}.
  Context {B: Type} (RB: relation B) `{!Equivalence RB}.

  Context (f: A -> A) `{!Proper (RA ==> RA) f}.
  Context (g: A -> B) `{!Proper (RA ==> RB) g}.

  Lemma example_4_4_4_ish: forall x, f (f (f x)) = x -> RA (f (f x)) x -> RB (g (f x)) (g x).
  Proof.
    intros.
    setoid_congruence RA, RB.
  Qed.
End example_4_4_4.



Require Import Coq.QArith.QArith_base.
Require Import Coq.QArith.Qreduction.


(* WHY IS THIS INSTANCE NOT ALLREADY EXTANT *)


Instance why : Proper (Qeq ==> Logic.eq) Qred.
Proof.
  intros x y H.
  now apply Qred_complete.
Qed.


Lemma example: forall x y, Qeq (Qplus x y) y -> Qred (Qplus x (Qplus x y)) = Qred y.
Proof.
  intros.
  setoid_congruence Qeq, (@Logic.eq Q).
Qed.



(* 
Section badExample.
  Context {A: Type} (RA RA': relation A) `{!Equivalence RA} `{!Equivalence RA'}.
  Context {B: Type} (RB: relation B) `{!Equivalence RB}.
  Context (f: A -> B) `{!Proper (RA ==> RB) f} `{!Proper (RA' ==> RB) f}.
  Lemma example_4_4_4_like: forall x y z, RA x y -> RA' y z -> RB (f x) (f z).
  Proof.
    intros.
    
    (* this is needed to make it work.... *)
    assert (U: RB (f y) (f y)).
    { reflexivity. }

    setoid_congruence RA, RA', RB.
  Qed.
  
End badExample. *)
