From Ltac2 Require Import Ltac2.

Ltac2 Type exn ::= [ Pick_Nil ].

(* Pick an array value from a list, branching value *)
Ltac2 rec from_list (a: 't list) := 
    match a with
    | [] => Control.zero Pick_Nil
    | (x :: xr) => Control.plus (fun () => x) (fun ext => from_list xr)
    end.

(* Pick an array value from a list, with a tupled with the rest of the list
   
   as of now it is best not to depend on the ordering properties of this as they are subject to change *)
Ltac2 rec from_list_with_rest_aux (cont: 't list) (a: 't list)
  := match a with
      | [] => Control.zero Pick_Nil
      | (x :: xr) => Control.plus (fun () => (x,List.rev_append cont xr))
                                  (fun ext => from_list_with_rest_aux (x :: cont) xr )
      end.
Ltac2 rec from_list_with_rest (a: 't list)  := from_list_with_rest_aux [] a.


(* Pick an interger from an interval *)
Ltac2 Type exn ::= [ Pick_Empty_Interval ].
Ltac2 rec from_range (min: int) (max: int)
  := match (Int.lt min max) with
      | false => Control.zero Pick_Empty_Interval
      | true => Control.plus (fun () => min) (fun _ => from_range (Int.add min 1) max)
      end.


(* pick items out of an array *)
Ltac2 rec from_array (a: 't array) := Array.get a (from_range 0 (Array.length a)).
