Set Universe Polymorphism.


Require Import Ltac2.Ltac2.


(* type of cc proofs, quantified by the type of axioms *)
Ltac2 Type rec 'a t :=
  [ Trans (int, 'a t, int, 'a t, int)
  | Sym( int, int, 'a t )
  | Ax (int, int, 'a ) 
  | Refl ( int ) 
  ].

(* note the argument order is funny for readablility *)
Ltac2 trans (a: int) (x: 'a t) (b: int) (y: 'a t) (c: int) := 
  match x with
  | Refl _ => y
  | _      => match y with
              | Refl _ => x
              | _ => Trans a x b y c
              end
  end.

Ltac2 sym (oldLhs: int) (oldRhs: int) (x: 'a t) := 
  match x with
  | Sym _ _ y => y
  | Refl r => Refl r
  | _ => Sym oldLhs oldRhs  x
  end.


Ltac2 refl (x: int) := Refl x.

(* TODO: make this handle refl
Ltac2 congL f f' x y y' e := CongL f f' x y y' e.
Ltac2 congR f x x' y y' e := CongR f x x' y y' e. *)

(* Ltac2 cong (f: int) (f' : int) (x : int) (x' : int) (y: int) (y': int) (fe: 'a t) (xe: 'a t) :=
  Cong f f' x x' y y' fe xe. *)

Ltac2 axiom (lhs: int) (rhs: int) (pf: 'a) := Ax lhs rhs pf.

(* acts like:
    ∀ x x' 
      y y', x = x' 
              -> y = y'
              -> x = y -> x' = y'  *)
Ltac2 transportEq (x: int) (x': int) (y: int) (y': int) (h1: 'a t) (h2: 'a t) (h3: 'a t) :=
  trans x' (trans x' (sym x x' h1) x h3 y) y h2 y'.
