Set Universe Polymorphism.


Require Import Utf8.
Require Import Coq.Relations.Relation_Definitions.
Require Import Coq.Classes.Morphisms.
Require Import Coq.Classes.Morphisms_Prop.

Class EAround {T: Type} (R: relation T) (pt: T) : Prop
  := {
    e_around_proper :> Proper R pt ;
    e_spec : ∀ x y,  R pt x -> R pt y -> R x y ;
    e_adopt_l : ∀ x y,  R pt x -> R x y -> R pt y ;
    e_adopt_r : ∀ x y,  R x y -> R pt y -> R pt x ;
  }.

Axiom dec : ∀ (P: Prop), {P} + {~P}.

(* Definition rfn {A B: Type} (f: A -> B) (x: A) (y: B) := λ pt, if (deq x pt) then y else (f pt). *)

Section e_around_weird.
  Context {A B: Type} (RA: relation A) (RB: relation B) (f: A -> B) (x: A).
  Definition cleverFn (u: B) := ∀ x, if (dec (RB (f x) u)) then u .
  
  (* Context (EAround (RA ==> RB)%signature f -> EAround RA x -> EAround RB (f x)) *)
End e_around_weird.

Lemma e_around_weird: ∀ {A B: Type} (RA: relation A) (RB: relation B) (f: A -> B) (x: A), EAround (RA ==> RB)%signature f -> EAround RA x -> EAround RB (f x).
Proof.
  intros.
  destruct H.
  destruct H0.

  assert (∀ y, RB (f x) y -> (RA ==> RB)%signature f (rfn f x y)).
  1: {
    unfold respectful, Proper, rfn in *.
    intros.
    destruct (deq x y0).
    + subst.
  }

  split; unfold respectful, Proper in *.
  + now apply e_around_proper0.
  + intros a b.
    

Qed.
